# Integration tests
    Would provide a container, easy mock/stubbing, maybe autoload container from dummy but don't do full initialization / application spinup?

# Fiddle
    mock-fs? mount-fs?
    
# Inspector
    Production mode
        Denali listens for usr signal, when recieved, starts Inspector
        $ denlali inspect app@api.foobar.com will ssh in, send usr signal, and start inspector gui

    Top level nav
        Output
    x       Log output
    x       Requests (when connected)
    x           Replay request
    x           Copy as test code
    x       Errors (when connected)
        Performance
            CPU / Memory (when connected)
            Build time flamegraph (https://rwjblue.github.io/heimdalljs-visualizer/#/flame)
        App
    x       Version info
            Routes
                If connected, simulate request to each
    x           API docs
            Databases / ORM adapters maybe?
            Analytics
                Map view
            Sockets
                Connected clients
                Routes
            Jobs
                Queues status
                Workers status
        Environment
            Dependencies
                * npm outdated --json
                Upgrade, show out of date
                Licenses (flag unknown and non-oss, https://github.com/davglass/license-checker)
                NSP results
            Environment variables
            Git status
            Migration status
                Rollback, migrate
        Docs
            Denali
            Addons
       ------------------------------ 
       In-app hooks needed:
            Log output
            Requests (when connected)
            Errors (when connected)
            CPU / Memory (when connected)
        
            Build time flamegraph (https://rwjblue.github.io/heimdalljs-visualizer/#/flame)
        App
            Version info
            Routes
                If connected, simulate request to each
                API docs
            Databases / ORM adapters maybe?
            Analytics
                Map view
            Sockets
                Connected clients
                Routes
            Jobs
                Queues status
                Workers status
        Environment
            Dependencies
                * npm outdated --json
                Upgrade, show out of date
                Licenses (flag unknown and non-oss, https://github.com/davglass/license-checker)
                NSP results
            Environment variables
            Git status
            Migration status
                Rollback, migrate
        Docs
            Denali
            Addons
        

    Denali-Fiddle
        Use browserify + fs mock + inspector style request submitter

    Denali needs denali build. Denali is denali build


# Warn on empty serializer

This is actually slightly more difficult to implement than expected. Most serializers will treat relationships and attributes differently, so we have the `attributesToSerialize()` and `relationshipsToSerialize()` helpers which return the respective whitelists - but these will often be invoked from different spots in the serializer (see the JSON-API serializer for example). And having a model with only attributes or only relationships is perfectly valid and common - so unless we can ensure that a serializer has no config for _both_, we can be sure we need to warn. Plus, we ideally want to do this in the base serializer class so any user-land serializers retain this warning ability.

So we could do the check in the base serializer class, before we delegate to the `this.serialize()` method, and just pass the list of attributes and relationships into the `this.serialize()` method (in case they are defined as functions with expensive computations, so we only run them once).

But that leads us to the problem of related serializers - if I'm rendering a Post with Comments, I want the PostSerializer to render the Post and CommentSerializer to render each Comment, but that means running something like `CommentSerializer.renderModel(comment)`, which will skip the `CommentSerializer.render()` method, which would have done the warning check.

Come to think of it, we probably want to pass the model into the attributes and relationships methods too (i.e. if I'm not an owner of this record, maybe I can only see a minimal set of fields).

Should serializers maybe not be singletons? We could instantiate them so we could eval attributes and relationships per model - but then is it once instance per model or one per response?

---

This is the wrong approach. We shouldn't care how the internals of a serializer are implemented - it's a blackbox. If someone wants to use a blacklist serializer,
for example, thats fine.

So this warning should be implemented per-serializer for built in types that are whitelist based.

We should update the builtins to pass the model into the `attributesToSerialize` and `relationshipsToSerialize` methods




### Watchtower

LEFT OFF

watchtower?
insight?
website
docs
build ascent blog backend


OVERWATCH

- Starts automatically in dev mode
- Starts with flag or SIGUSR2

Build process

- Build process similar to addons - addons are precompiled usually, but if not, compiled on the file
- Compilation shouldn't block main process

Runtime

- Denali ships with wrapper client app which loads different Facets
- A Facet is an Ember Engine which corresponds to a top level nav / section of Watchtower
- Core Facets:
  - Requests
  - Sockets
  - Resource Usage
  - Logs
  - Audit
  - Docs
- App/addons can ship their own Facets
- App/addons can ship their own Watchtower API extensions as well
- Watchtower API is just another Denali app that gets launched

---

- API side of watchtower (behavior at least) will be handled by regular denali actions. Addons can add their own actions/routes/etc
- Client side handled by ember engines, because we need integrated routing, which apparently no one else does well
- Can we precompile the ember engine and manually recreate the lazy engine output? I.e. copy into engines-dist? Probably not without some complexity, since we need to generate the asset-manifest too, and stitch them in
  - For now, compile everything on the fly, precompiled Facets can be an optimization
- How does client compilation happen? Ask each builder for `watchtowerDir`, which returns a path to their Facet (Ember Engine). These are symlinked into a tmp dir to create the source structure Ember expects
- How does client get data like docs?
  - Actions are compiled just like normal denali addon stuff, so the addon that wants to extract data from the app to make available to watchtower
    would simply use parentBuilder.dir to inspect the consuming app's package.
    - But how would we generate docs for _all_ addons?
    - Each addon will necessarily have Denali as a dep
    - Denali gets a parentTree invocation for every addon + the app then
    - Docs compilation is expensive - precompile is _required_
    - So denali checks for precompiled, if not there, compiles on the file, either way wraps parent with docs included tree
    - When you publish an addon, you run denali build, which would build docs
    - Need a --no-docs arg, so builder needs build args passed in

---

Changes:
- [x] Pass build args into builders layer (including child builder parentTree invocations)
- [x] Builders can supply an watchtowerConfig
  - [x] dir: source dir for engine
  - [x] dependencies: EmberApp dependency config, see https://github.com/ember-engines/ember-engines#linking-to-external-routes
  - [x] mountpath: url to mount to, defaults to addon name - denali prefix
- [x] Denali's parentTree checks for --no-docs
  - [x] if not present, checks for precompiled docs
    - [x] if not present, wraps parent tree with docs compilation
      - docs tree compiles JSON flat files from markdown guides, source comments, and config
    - [x] if present, returns parent tree unchanged
- [ ] Docs action looks up docs data in addon built dirs
- [ ] Project class adds `startWatchtower()` method
  - [ ] Walks child builders, gets watchtowerFacetDirs
  - [ ] Takes Denali /watchtower dir, copies to tmp
  - [ ] Symlinks various watchtowerFacetDirs into faked node_modules
  - [ ] Shells out to ember serve


  left off - get build w/ ember going so we can start hitting the actual API